# AUTOGENERATED! DO NOT EDIT! File to edit: ../../nbs/environments/21_feature_converters.ipynb.

# %% auto 0
__all__ = ['feature_oracle']

# %% ../../nbs/environments/21_feature_converters.ipynb 4
# General libraries:
import numpy as np

# %% ../../nbs/environments/21_feature_converters.ipynb 5
def feature_oracle(features, window = 10, flat = False):
    """

    Takes a matrix of features where n is the number of time steps and m is the number of features.
    For each feature it adds as many columns as the window size where each column is the feature n+1 time steps in the future.

    Args:
        features (np.array): Array of features.
        window (int): Window size how many future features to add
        flat (bool): If True, the output is a 2D array. If False, the output is a 3D array.
    """

    oracle_features = np.zeros((features.shape[0]-window, features.shape[1], window+1))

    for i in range(window+1):
        if i == window:
            oracle_features[:, :, i] = features[i:,:].copy()
        else:
            oracle_features[:, :, i] = features[i:-window+i,:].copy()

    if flat:
        oracle_features = oracle_features.reshape((oracle_features.shape[0], oracle_features.shape[1] * oracle_features.shape[2]))

    return oracle_features
